;jQuery(function($){
	// Helpers
	$.spip.select2 = {
		markMatch: function(text, term) {
			// Find where the match is
			var match = text.toUpperCase().indexOf(term.toUpperCase());

			var $result = $('<span></span>');

			// If there is no match, move on
			if (match < 0) {
				return $result.text(text);
			}

			// Put in whatever text is before the match
			$result.text(text.substring(0, match));

			// Mark the match
			var $match = $('<span class="select2-rendered__match"></span>');
			$match.text(text.substring(match, match + term.length));

			// Append the matching text
			$result.append($match);

			// Put in whatever is after the match
			$result.append(text.substring(match + term.length));

			return $result;
		},
		transport: function (params, success, failure) {
			// utiliser l’ajax natif de jquery pour pas déclencher onAjaxLoad
			// à chaque appel à l’autocomplete ...
			if (typeof $.spip.intercepted.ajax === "function") {
				var $request = $.spip.intercepted.ajax(params);
			} else {
				var $request = $.ajax(params);
			}
			$request.then(success);
			$request.fail(failure);
			return $request;
		}
	};
	// Appel de Select2, en prenant en compte quelques options en plus
	$.fn.spip_select2 = function(options) {
		var opts = options || {};
		this.each(function(){
			var $select = $(this);
			var options = opts || {};

			// Éviter des onAjaxLoad() sur les hits autocomplete
			if ($select.data('ajax-url')) {
				options = $.extend(true, {
					ajax: {
						delay: 250, // can be overriden with data-ajax-delay="..."
						transport: $.spip.select2.transport
					}
				}, options);
			}

			if (options.sortAlpha || $select.data('sort-alpha')) {
				options = $.extend(true, {
					sorter: function (data) {
						return data.sort(function (a, b) {
							return a.text.localeCompare(b.text);
						})
					}
				}, options);
			}
			if (options.highlightSearchTerm || $select.data('highlight-search-term')) {
				options = $.extend(true, {
					templateResult: function(item) {
						if (item.loading) {
							return item.text;
						}
						var term = $('input.select2-search__field[aria-controls]').val();
						if (!term || !term.length) {
							return item.text;
						}
						return $.spip.select2.markMatch(item.text, term);
					}
				}, options);
			}

			$select.select2(options);
		});
	};

	spip_select2 = function() {
		var $selects = $('select.select2');
		if (typeof select2 !== 'undefined') {
			if ((typeof select2.selector !== 'undefined') && !!select2.selector) {
				$selects = $selects.add($(select2.selector));
			}
		}
		// Select2 avec quelques options en plus...
		$selects.spip_select2();
	};

	spip_select2();
	onAjaxLoad(spip_select2);
});

